<?php

namespace App\Controller;

use App\Entity\Note;
use App\Service\AnkiService;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Attribute\Route;

#[Route('/anki', name: 'app_anki_')]
class AnkiController extends AbstractController
{
    function __construct(
        private AnkiService $ankiService,
    ) {}

    public static function tmpl(string $path): string
    {
        return "anki/$path.html.twig";
    }

    #[Route('/', name: 'main')]
    public function index(): Response
    {
        $allIds = $this->ankiService->getAllNoteIds();

        $allNotes = $this->ankiService->getNotes($allIds);

        dd($allNotes);
    }

    #[Route('/nonconforming', name: 'nonconforming')]
    public function nonconforming(): Response
    {
        $allIds = $this->ankiService->getAllNoteIds();

        $allNotes = $this->ankiService->getNotes($allIds);

        $lacking = array_filter($allNotes, function ($note) {
            assert($note instanceof Note);
            return empty($note->getTerms());
        });

        return $this->render(self::tmpl('nonconforming'), [
            'notes' => $lacking,
        ]);
    }

    #[Route('/note/{nid}/get', name: 'get_note')]
    public function get_note(int $nid)
    {
        $note = $this->ankiService->getNote($nid);
        //$this->ankiService->updateNote($note);
        dd($note);
    }
}
